/**************************************************************************/
/*                  選択した文字に置換する（書式なし） ＣＳ２用           */
/*                                                           by お～まち  */
/*                                              2009.04.30  Version 1.01  */
/**************************************************************************/
app.scriptPreferences.userInteractionLevel=UserInteractionLevels.interactWithAll;
if (app.selection.length != 1){
    alert("置換後の文字列を選択してください");
} else {
    switch (app.selection[0].constructor.name){
        case "Story":
        case "Text":
        case "TextStyleRange":
        case "TextColumn":
        case "Paragraph":
        case "Line":
        case "Word":
        case "Character":
            chng_str (app.selection[0]);
            break;
        default:
            alert("置換後の文字列を選択してください");
    }
}

function chng_str(selstr){
    //ダイアログ作成
    dlg = app.dialogs.add({name:"検索文字列の設定"});
    dlc = dlg.dialogColumns.add();
    with (dlc.dialogRows.add()){
        staticTexts.add({staticLabel:"検索文字列を指定してください"});
    }
    with (dlc.dialogRows.add()){
        var dlt = textEditboxes.add();
    }
    with (dlc.dialogRows.add()){
        var dc1 = checkboxControls.add({staticLabel:"カナを区別",checkedState:true});
        var dc3 = checkboxControls.add({staticLabel:"単語として検索",checkedState:false});
    }
    with (dlc.dialogRows.add()){
        var dc2 = checkboxControls.add({staticLabel:"半角・全角を区別",checkedState:true});
        var dc4 = checkboxControls.add({staticLabel:"大文字／小文字を区別",checkedState:true});
    }
    //入力チェック
    err_flag = true;
    while(err_flag){
        if(!dlg.show()) return;
        err_flag = false;
        if(dlt.editContents == ""){
            alert("検索文字列を入力してください");
            err_flag = true;
        }
    }
    //置換後に位置情報が変わる場合に備えて属性情報を変数に格納
    //三島梅花藻さん　感謝！
    var repchr = new Array();
    for (i=0; i<selstr.length; i++){
        repchr[i] = new saveOtf(selstr.characters[i]);
    }
    //置換実行
    ser = app.search(dlt.editContents, dc1.checkedState, dc2.checkedState,
            dc3.checkedState, dc4.checkedState, selstr.contents);
    //属性のコピー
    for (i=0; i<ser.length; i++){
        for (j=0; j<repchr.length; j++){
            //CS2の場合はopentypeFeatures
            ser[i].characters[j].opentypeFeatures = repchr[j].opentypeFeatures;
            ser[i].characters[j].glyphForm = repchr[j].glyphForm;
            ser[i].characters[j].otfTitling = repchr[j].otfTitling;
            ser[i].characters[j].otfSwash = repchr[j].otfSwash;
            ser[i].characters[j].otfContextualAlternate = repchr[j].otfContextualAlternate;
            ser[i].characters[j].otfOrdinal = repchr[j].otfOrdinal;
            ser[i].characters[j].otfFraction = repchr[j].otfFraction;
            ser[i].characters[j].otfDiscretionaryLigature = repchr[j].otfDiscretionaryLigature;
            ser[i].characters[j].otfFigureStyle = repchr[j].otfFigureStyle;
            ser[i].characters[j].otfHVKana = repchr[j].otfHVKana;
            ser[i].characters[j].otfProportionalMetrics = repchr[j].otfProportionalMetrics;
            ser[i].characters[j].otfRomanItalics = repchr[j].otfRomanItalics;
            ser[i].characters[j].otfSlashedZero = repchr[j].otfSlashedZero;
            ser[i].characters[j].otfStylisticSets = repchr[j].otfStylisticSets;
        }
    }
    dlg.destroy();
    alert(ser.length + "カ所置換しました");
}

function saveOtf(chr){
    this.opentypeFeatures = chr.opentypeFeatures;
    this.glyphForm = chr.glyphForm;
    this.otfTitling = chr.otfTitling;
    this.otfSwash = chr.otfSwash;
    this.otfContextualAlternate = chr.otfContextualAlternate;
    this.otfOrdinal = chr.otfOrdinal;
    this.otfFraction = chr.otfFraction;
    this.otfDiscretionaryLigature = chr.otfDiscretionaryLigature;
    this.otfFigureStyle = chr.otfFigureStyle;
    this.otfHVKana = chr.otfHVKana;
    this.otfProportionalMetrics = chr.otfProportionalMetrics;
    this.otfRomanItalics = chr.otfRomanItalics;
    this.otfSlashedZero = chr.otfSlashedZero;
    this.otfStylisticSets = chr.otfStylisticSets;
    return this;
}
